/*
	mklf24h.c[pp]

*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <time.h>			/* for fileinfo */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#pragma pack(1)
typedef struct fx2hdr {
	char	id[6];
	char	name[8];
	char	width;
	char	height;
	char	flag;
	unsigned char	body[];
} fx2hdr;

/*
	=====================================
	Susie SPI ֌W 
	A[JCu甲̂ɕKvȏ 
	=====================================
*/

typedef struct fileInfo {
	unsigned char	method[8];
	unsigned long	pos;
	unsigned long	compressed_size;
	unsigned long	size;
	time_t			timestamp;
	char			path[200];
	char			name[200];
	unsigned long	crc;
} FILEINFO, *PFILEINFO, FAR * LPFILEINFO;

#pragma pack()


typedef int (__export FAR PASCAL *	LPFNGETPLUGININFO)(int, LPSTR, int);
typedef int (__export FAR PASCAL *	LPFNISSUPPORTED)(LPSTR, DWORD);
typedef int (__export FAR PASCAL *	LPFNGETARCHIVEINFO)(LPSTR, long, unsigned, HGLOBAL FAR *);
typedef int (__export FAR PASCAL *	LPFNGETFILEINFO)(LPSTR, long, LPSTR, unsigned, LPFILEINFO);
typedef int (__export FAR PASCAL *	LPFNGETFILE)(LPSTR, long, LPSTR, unsigned, FARPROC, long);

typedef struct spi32 {
	HMODULE					hm;
	LPFNGETPLUGININFO		lpfnGetPluginInfo;
	LPFNISSUPPORTED			lpfnIsSupported;
	LPFNGETARCHIVEINFO		lpfnGetArchiveInfo;
	LPFNGETFILEINFO			lpfnGetFileInfo;
	LPFNGETFILE				lpfnGetFile;
} spi32;


BOOL
loadSpi(const char *name, spi32 * spi)
{
	const CHAR	szreg[] = "Software\\Takechin\\Susie\\Plug-in";
	const CHAR	szent[] = "Path";
	char	spath[MAX_PATH];
	LONG	regres;
	HKEY	hk;
	DWORD	dw, dwtype;
	HMODULE	hm;
	FARPROC	fn;
	
	if (spi->hm != NULL)	return FALSE;
	
	/* Susie Ăꍇ Susie ̃pXvOCDǂݍ */
	
	*spath = '\0';
	regres = RegOpenKeyEx(HKEY_CURRENT_USER, szreg, 0, KEY_READ, &hk);
	if (regres == ERROR_SUCCESS) {
		dw = sizeof(spath) / sizeof(BYTE);
		dwtype = REG_SZ;
		regres = RegQueryValueEx(hk, szent, NULL, &dwtype, spath, &dw);
	}
	
	hm = NULL;
	if (regres == ERROR_SUCCESS) {
		lstrcat(spath, "\\");
		lstrcat(spath, name);
		hm = (HMODULE)LoadLibrary(spath);
	}
	
	/* Susie ĂȂƂA Susie ̃pXɊYvOC 
	   ͂ĂȂꍇ LoadLibrary API ̃ftHgŒTĂ݂ */
	if (!hm)	hm = (HMODULE)LoadLibrary(name);
	/* łȂ΃AfBIXA~[S */
	if (!hm)	return FALSE;
	
	
	fn = GetProcAddress(hm, "GetPluginInfo");
	spi->lpfnGetPluginInfo = (LPFNGETPLUGININFO)fn;
	fn = GetProcAddress(hm, "IsSupported");
	spi->lpfnIsSupported = (LPFNISSUPPORTED)fn;
	fn = GetProcAddress(hm, "GetArchiveInfo");
	spi->lpfnGetArchiveInfo = (LPFNGETARCHIVEINFO)fn;
	fn = GetProcAddress(hm, "GetFileInfo");
	spi->lpfnGetFileInfo = (LPFNGETFILEINFO)fn;
	fn = GetProcAddress(hm, "GetFile");
	spi->lpfnGetFile = (LPFNGETFILE)fn;
	
	spi->hm = hm;
	
	return TRUE;
}


BOOL
unloadSpi(spi32 * spi)
{
	BOOL	result;
	
	if (spi->hm == NULL)	return TRUE;
	result = FreeLibrary(spi->hm);
	if (result == TRUE) {
		spi->hm = NULL;
	}
	
	return result;
}



int
queryPak(char * path, int lim, int sopt)
{
	const CHAR	szkey_th[] = "Software\\Leaf\\ToHeart";
	const CHAR	szent_thdir[] = "DataDir";
	const CHAR	szpak_th[] = "\\LVNS3DAT.PAK";
	const CHAR	szini_kz[] = "KIZUATO.INI";
	const CHAR	szsec_kz[] = "";
	const CHAR	szent_kzdir[] = "KizuatoDir";
	const CHAR	szpak_kz[] = "\\MAX2DATA.PAK";
	const CHAR	szini_sz[] = "SIZUKU.INI";
	const CHAR	szsec_sz[] = "";
	const CHAR	szent_szdir[] = "SizukuDir";
	const CHAR	szpak_sz[] = "\\MAX_DATA.PAK";

	int		result = 0;
	LONG	regres;
	HKEY	hk;
	DWORD	dw, dwtype;
	
	switch(sopt) {
		
		case 3:		/* To Heart */
			dw = lim - 14;
			regres = RegOpenKeyEx(
						HKEY_CURRENT_USER,
						szkey_th,
						0,
						KEY_READ,
						&hk);
			if (regres == ERROR_SUCCESS) {
				dwtype = REG_SZ;
				regres = RegQueryValueEx(
							hk,
							szent_thdir,
							NULL,
							&dwtype,
							path,
							&dw);
				
				if (regres == ERROR_SUCCESS) {
					lstrcat(path, szpak_th);
					result = sopt;
					break;
				}
			}
		
		case 2:		/*  */
			dw = lim - 14;
			GetPrivateProfileString(
				szsec_kz,
				szent_kzdir,
				"",
				path,
				dw,
				szini_kz);
			
			if (*path != '\0') {
				lstrcat(path, szpak_kz);
				result = sopt;
				break;
			}
		
		case 1:		/*  */
			dw = lim - 14;
			GetPrivateProfileString(
				szsec_sz,
				szent_szdir,
				"",
				path,
				dw,
				szini_sz);
			
			if (*path != '\0') {
				lstrcat(path, szpak_sz);
				result = sopt;
				break;
			}
		
		default:
			break;
	}
	
	return result;
}


static char *		destf;
static char *		optp;
static char *		optd = "LFSTBH24.FNT";
static int			opthelp;

int
fetchopts(int argc, char **argv)
{
	int		params = 0;
	char *	s;
	
	while(argc--) {
		s = *argv++;
		
		if (*s == '-' || *s == '/') {
			s++;
			if (*s == '?' || *s == 'h' || *s == 'H') { opthelp = 1; params++; }
			if (memicmp(s, "p=", 2) == 0) { optp = s + 2; params++; }
			if (memicmp(s, "d=", 2) == 0) { optd = s + 2; params++; }
		} else {
			if (!destf)	{ destf = s; params++; }
		}
	}
	
	return params;
}


void *
loadFile2Mem(const char * name)
{
	FILE *	f;
	long	len;
	void *	p;
	
	f = fopen(name, "rb");
	if (f == NULL) return NULL;
	
	fseek(f, 0L, SEEK_END);
	len = ftell(f);
	if (len == -1L) { fclose(f); return NULL; }
	fseek(f, 0L, SEEK_SET);
	
	p = malloc(len);
	if (p != NULL) {
		fread(p, len, 1, f);
	}
	if (f != NULL) fclose(f);
	return p;
}

int
saveMem2File(const char * name, const void * mem, long len)
{
	FILE *		f;
	int			result;
	
	f = fopen(name, "wb");
	if (f == NULL) return 0;
	result = (int)fwrite(mem, len, 1, f);
	fclose(f);
	return result;
}


int FAR PASCAL gfCallback(int num, int denom, long lprm)
{
	return 0;
}

int
getFile2Archive(spi32 * spi, HGLOBAL *hmem, char * pakfile, char *name)
{
	int			result;
	HFILE		hf;
	FILEINFO 	fi;
	
	*hmem = NULL;
	if (spi->hm == NULL) return -1;
	
	hf = _lopen(pakfile, OF_READ);
	if (hf == HFILE_ERROR) return -1;
	result = spi->lpfnIsSupported(pakfile, (DWORD)hf & 0xffffUL);
	_lclose(hf);
	if (!result) return -1;
	
	result = spi->lpfnGetFileInfo(pakfile, 0L, name, 0x80U, &fi);
	if (result == 0) {
		result = spi->lpfnGetFile(
					pakfile,
					fi.pos,
					(LPVOID)hmem,
					0x0100,
					gfCallback,
					0);
	}
	
	return result;
}


unsigned char
shrinkw2b(unsigned short w)
{
	const unsigned char	bm[4] = { 0x00, 0x80, 0x80, 0x80 };
	unsigned char	b;
	int				i;
	
	i = 8;
	while(i--) {
		b >>= 1;
		b |= bm[w & 3];
		w >>= 2;
	}
	return b;
}

void
shrink24(unsigned char *dest, unsigned char * src)
{
	unsigned char	c;
	unsigned short	w;
	int		y;
	
	for(y=0; y<24; y++) {
		w = ((unsigned short)(src[0]) << 8) | (unsigned short)(src[1]);
		*dest++ = shrinkw2b(w);
		w = ((unsigned short)(src[2]) << 8);
		*dest++ = shrinkw2b(w);
		src += 3;
	}
}

void
patchFonts(fx2hdr *dest, VOID FAR * src)
{
	int				ftop[] = { 0x01, 0x1b, 0x35, 0x90, 0xd7 };
	unsigned char	*fseq[] = {
		"ABCDEFGHIJKLMNOPQRSTUVWXYZ",
		"abcdefghijklmnopqrstuvwxyz",
		"0123456789",
		"ܦ",
		""
	};
	int				i, j, n;
	unsigned char *	s;
	unsigned int	c;
	for(i=0; i< (sizeof(ftop) / sizeof(ftop[0])); i++) {
		j = ftop[i];
		s = fseq[i];
		n = strlen(s);
		while(n--) {
			c = (unsigned int)(*s);
			if (c == 0) break;
			shrink24(&(dest->body[c * 2 *24]), ((LPBYTE)src) + j * 3 * 24);
			s++;
			j++;
		}
	}
	return;
}

void
usage(void)
{
	puts("mklf24h [-p=pakfile] [-d=dummyfile] output\n");
}

int main(int argc, char **argv)
{
	const CHAR	szspi[] = "AXLFPAK.SPI";
	int			result = 1;
	spi32		spi;
	fx2hdr *	fx;
	char		s[270];
	HGLOBAL		hmem = NULL;
	
	if (fetchopts(argc - 1, argv + 1) == 0 || opthelp != 0) {
		usage();
		return 0;
	}
	
	
	spi.hm = NULL;
	if (!loadSpi(szspi, &spi)) {
		fprintf(stderr, "%s ܂łB\n", szspi);
		return 1;
	}

	fx = (fx2hdr *)loadFile2Mem(optd);
	if (fx == NULL) {
		fprintf(stderr, "\"%s\" ǂݍ߂܂łB\n", optd);
	} else {
		if (optp == NULL) {
			optp = (queryPak(s, sizeof(s), 3) !=0 ) ? s : NULL;
		}
		if (optp == NULL) {
			fprintf(stderr, "PAK t@C܂B\n");
		} else {
			result = getFile2Archive(&spi, &hmem, optp, "KNJ_ALL.KNJ");
			if (result != 0) {
				fprintf(stderr, "tHg̓WJɎs܂ (errcode=%d)", result);
			} else {
				patchFonts(fx, GlobalLock(hmem));
				GlobalUnlock(hmem);
				result = saveMem2File(destf, fx, 12305);/* TCYߑł... */
				if (!result) {
					fprintf(stderr, "\"%s\" 쐬s\n", destf);
				}
			}
		}
	}
	
	if (hmem != NULL) GlobalFree(hmem);
	if (fx != NULL) free(fx);
	unloadSpi(&spi);
	return result;
}
